#include "decompose.h"
#include "wlt.h"
#include <cstring>
#include <iostream>
#include <cwchar>
#include <fstream>
#include <string>
#include <locale>
#include <wchar.h>
#include <stdio.h>
using namespace std;

void uchar2wchar(unsigned char* uchar,  size_t uchar_count, wchar_t* wchar)
{
	int i;
	size_t wchar_count = uchar_count / 2;	
	for (i = 0; i < wchar_count; i++) {
		wchar[i] = uchar[i * 2] | (uchar[i*2 + 1] << 8);
	}
	wchar[wchar_count] = L'\0';
}

int main() {

	setlocale(LC_ALL, "");
	// 打开端口
	int ret;

	ret = FRI_OpenPort(1001);
	if (ret != 0x90)
	{
		std::wcout << L"打开机具失败，错误码：" << ret << endl;
		return 1;
	}

	while(true) {
		std:wcout << L"开始找卡......" << endl;
		ret = FRI_FindIDCard(1001);
		if (ret == 0x90)
		{
			std::wcout << L"找卡成功" << endl;
			break;
		}
	}

	CardInfoStruct* docInfo = new CardInfoStruct();
	unsigned char pPHMsg[38862] = {0};
	unsigned int pPHMsgLen = 0;
	unsigned char pFPMsg[1024] = {0};
	unsigned int pFPMsgLen = 0;

	ret = FRI_ReadIDCard(1001, docInfo, pPHMsg, &pPHMsgLen, pFPMsg, &pFPMsgLen, 0);
	if (ret != 0x90) {
		std::wcout << L"读卡错误，结果为：" << ret << endl;
		return 1;
	}
	
	// 测试写入bmp数据至文件
	const char* filePath = "face.bmp";
	std::ofstream outFile(filePath, std::ios::binary);
	outFile.write(reinterpret_cast<const char*>(pPHMsg), pPHMsgLen);
	outFile.close();

	const wchar_t* wide = L"------个人信息------ ";
	std::wcout << wide << endl;
	wchar_t wide_string[61];
	int type = docInfo->cardType;
	if (type == 3) {
		cout << "证件类型: 2017版永居证" << endl;
		uchar2wchar(docInfo->yjzOld_nameEnglish, 120, wide_string);
		std::wcout << "English Name: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjzOld_gender, 6, wide_string);
		std::wcout << "Gender: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjzOld_idNumber, 30, wide_string);
		std::wcout << "ID: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjzOld_nationality, 6, wide_string);
		std::wcout << "Nationality: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjzOld_nameChinese, 30, wide_string);
		std::wcout << "Chinese Name: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjzOld_validDateStart, 16, wide_string);
		std::wcout << "Issue Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjzOld_validDateEnd, 16, wide_string);
		std::wcout << "End Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjzOld_birthday, 16, wide_string);
		std::wcout << "Birth Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjzOld_cardVersion, 4, wide_string);
		std::wcout << "Doc Version: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjzOld_issueOrganization, 8, wide_string);
		std::wcout << "Issuing Authority: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjzOld_cardType, 2, wide_string);
		std::wcout << "Document Type: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjzOld_reserved, 6, wide_string);
		std::wcout << "Reserve: " << wide_string << std::endl;

	} else if (type == 4) {
		cout << "证件类型: 新版永居证" << endl;
		uchar2wchar(docInfo->yjz_nameChinese, 30, wide_string);
		std::wcout << "Chinese Name: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_gender, 6, wide_string);
		std::wcout << "Gender: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_idNumber, 36, wide_string);
		std::wcout << "ID: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_nationality, 6, wide_string);
		std::wcout << "Nationality: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_nameEnglish, 70, wide_string);
		std::wcout << "English Name: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_validDateStart, 16, wide_string);
		std::wcout << "Start Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_validDateEnd, 16, wide_string);
		std::wcout << "End Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_birthday, 16, wide_string);
		std::wcout << "Birth Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_renewalNumber, 4, wide_string);
		std::wcout << "Renewal Number: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_cardType, 2, wide_string);
		std::wcout << "Document Type: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_nameEnglishAdd, 22, wide_string);
		std::wcout << "Alternate English Name: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_releatedItems, 6, wide_string);
		std::wcout << "Releated Items: " << wide_string << std::endl;
		uchar2wchar(docInfo->yjz_historicalNumber, 30, wide_string);
		std::wcout << "Historical ID: " << wide_string << std::endl;
	} else if (type == 2) {
		cout << "证件类型: 港澳证" << endl;
		uchar2wchar(docInfo->gat_name, 30, wide_string);
		std::wcout << "Name: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_gender, 6, wide_string);
		std::wcout << "Gender: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_idNumber, 36, wide_string);
		std::wcout << "ID: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_address, 70, wide_string);
		std::wcout << "Address: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_validDateStart, 16, wide_string);
		std::wcout << "Start Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_validDateEnd, 16, wide_string);
		std::wcout << "End Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_birthday, 16, wide_string);
		std::wcout << "Birth Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_issuesNumber, 4, wide_string);
		std::wcout << "Issue Number: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_issueOrganization, 30, wide_string);
		std::wcout << "Issuing Authority: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_cardType, 2, wide_string);
		std::wcout << "Document Type: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_passCheckId, 18, wide_string);
		std::wcout << "Pass Check ID: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_reserved1, 4, wide_string);
		std::wcout << "Reserve1: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_reserved2, 6, wide_string);
		std::wcout << "Reserve2: " << wide_string << std::endl;
		uchar2wchar(docInfo->gat_reserved3, 6, wide_string);
		std::wcout << "Reserve3: " << wide_string << std::endl;
	} else {
		cout << "证件类型: 身份证" << endl;
		uchar2wchar(docInfo->sfz_name, 30, wide_string);
		std::wcout << "Name: " << wide_string << std::endl;
		uchar2wchar(docInfo->sfz_gender, 6, wide_string);
		std::wcout << "Gender: " << wide_string << std::endl;
		uchar2wchar(docInfo->sfz_nation, 8, wide_string);
		std::wcout << "Nation: " << wide_string << std::endl;
		uchar2wchar(docInfo->sfz_idNumber, 36, wide_string);
		std::wcout << "ID: " << wide_string << std::endl;
		uchar2wchar(docInfo->sfz_address, 70, wide_string);
		std::wcout << "Address: " << wide_string << std::endl;
		uchar2wchar(docInfo->sfz_validDateStart, 16, wide_string);
		std::wcout << "Start Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->sfz_validDateEnd, 16, wide_string);
		std::wcout << "End Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->sfz_birthday, 16, wide_string);
		std::wcout << "Birth Date: " << wide_string << std::endl;
		uchar2wchar(docInfo->sfz_nation, 8, wide_string);
		std::wcout << "Ethnic Group: " << wide_string << std::endl;
		uchar2wchar(docInfo->sfz_issueOrganization, 30, wide_string);
		std::wcout << "Issuing Authority: " << wide_string << std::endl;
		uchar2wchar(docInfo->sfz_reserved, 36, wide_string);
		std::wcout << "Reserve: " << wide_string << std::endl;
	}

	delete docInfo;
	FRI_ClosePort(1001);

	return 0;
}
